#include "Label.h"
#include "TextElement.h"

Label::Label()
    : Widget(),
      mLabel()
{

}

std::unique_ptr<Label> Label::Create()
{
    return std::make_unique<Label>();
}

void Label::SetLabel(const std::string& text)
{
    mLabel = text;
}

void Label::OnPaintEvent(const PaintEvent* event)
{
    mMyLayers.clear();
    AddBackground(event);

    if(!mLabel.empty())
    {
        auto middle = DiscretePoint(mLocation.GetX() + mWidth/2,
                mLocation.GetY() + mHeight/2);
        auto textLayer = VisualLayer::Create();
        textLayer->SetText(TextElement::Create(mLabel, middle));
        mMyLayers.push_back(std::move(textLayer));
    }
    CopyMyLayers();
}
