#pragma once

#include <memory>
#include <string>

#include "DiscretePoint.h"

class TextElement
{
    std::string mContent;
    DiscretePoint mLocation;
    std::string mFontLabel;

public:

    TextElement(const std::string& content, const DiscretePoint& loc);

    ~TextElement();

    static std::unique_ptr<TextElement> Create(const std::string& content, const DiscretePoint& loc);

    DiscretePoint GetLocation() const;

    std::string GetContent() const;

    std::string GetFontLabel() const;

    void SetContent(const std::string& content);
};

using TextElementUPtr = std::unique_ptr<TextElement>;
